package com.memorynotfound.springboot.test;

import com.memorynotfound.springboot.Application;
import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;
import org.springframework.boot.test.rule.OutputCapture;
import static org.assertj.core.api.Assertions.assertThat;

public class ApplicationTest {

    @Rule
    public OutputCapture outputCapture = new OutputCapture();

    @Before
    public void before() {
        System.clearProperty("spring.profiles.active");
    }

    @Test
    public void testDefaultProfile() throws Exception {
        Application.main();
        assertThat(getConsoleOutput())
                .contains("default@email.com")
                .contains("common-profile-name");
    }

    @Test
    public void testDevelopmentProfile() throws Exception {
        System.setProperty("spring.profiles.active", "dev");
        Application.main();
        assertThat(getConsoleOutput())
                .contains("development@email.com")
                .contains("common-profile-name");
    }

    @Test
    public void testProductionProfile() throws Exception {
        Application.main("--spring.profiles.active=prod");
        assertThat(getConsoleOutput())
                .contains("production@email.com")
                .contains("common-profile-name");
    }


    private String getConsoleOutput(){
        return outputCapture.toString();
    }
}
